//Source & infos: https://homofaciens.de/technics-miscellaneous-electric-generator_en.htm

// LCD RS pin to digital pin      8
// LCD Enable pin to digital pin  9
// LCD D4 pin to digital pin     10
// LCD D5 pin to digital pin     11
// LCD D6 pin to digital pin     12
// LCD D7 pin to digital pin     13
// LCD R/W pin to ground
// 10K potentiometer:
// ends to +5V and ground
// wiper to LCD VO pin (pin 3)


// include the library code:
#include <LiquidCrystal.h>

char lineText[]="  Hello World!  ";
int i = 0;
int j = 0;
char readByte;
int jStart = 0;

#define LCD_RS       8
#define LCD_EN       9
#define LCD_D0      10
#define LCD_D1      11
#define LCD_D2      12
#define LCD_D3      13
#define ADC0        A0
#define HALL_SENSOR A1

long rpm = 0;
char LCD_line_1[20];
char LCD_line_2[20];
float ADC0_value = 0;
long voltage = 0;


// initialize the library with the numbers of the interface pins
LiquidCrystal lcd(LCD_RS, LCD_EN, LCD_D0, LCD_D1, LCD_D2, LCD_D3);


void sensorTriggered(unsigned long bounce_pause) {
  unsigned long timeStart, timeNow;
  unsigned long triggerPause = 0;

  while(triggerPause < bounce_pause){
    timeStart = millis();
    while(digitalRead(HALL_SENSOR) == 1);
    triggerPause = millis()-timeStart;
  }
  triggerPause = 0;
  while(triggerPause < bounce_pause){
    timeStart = millis();
    while(digitalRead(HALL_SENSOR) == 0);
    triggerPause = millis()-timeStart;
  }

}


long get_rev_speed(unsigned long wait_time){
  long rpm = 0;
  long pulses=0;
  unsigned long MillisStart;

  MillisStart = millis();

  while(millis()-MillisStart < wait_time){
    sensorTriggered(2);
    pulses++;
  }

  rpm = (long)((double)(pulses * 60.0)/(wait_time/1000.0));

  return rpm;
}


void setup() {
  pinMode(HALL_SENSOR, INPUT);
  pinMode(ADC0, INPUT);
  // set up the LCD's number of columns and rows:
  lcd.begin(16, 2);
  // Print a message to the LCD.
  lcd.setCursor(0, 0);
  lcd.print("Arduino UNO     ");
  lcd.setCursor(0, 1);
  lcd.print("                ");
  delay(2000);

}

void loop() {
    ADC0_value = analogRead(ADC0);
    //voltage=(27.0+5.6)/5.6 * 5.0*(double)(ADC0_value)/1023.0;
    voltage=(long)((double)(1000.0*28.0*(double)(ADC0_value)/1023.0));

    sprintf(LCD_line_1, "Crank =% 6drpm",  rpm);
    lcd.setCursor(0,0);
    lcd.print(LCD_line_1);
    sprintf(LCD_line_2, "Output=% 6dmV ",  voltage);
    lcd.setCursor(0,1);
    lcd.print(LCD_line_2);
    rpm = get_rev_speed(3000);
}


